diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.32/src/mpi/model/null-message-mpi-interface.cc ns-3.33/src/mpi/model/null-message-mpi-interface.cc
--- ns-3.32/src/mpi/model/null-message-mpi-interface.cc	2020-10-06 15:35:43.000000000 -0700
+++ ns-3.33/src/mpi/model/null-message-mpi-interface.cc	2021-01-09 10:19:22.000000000 -0800
@@ -19,6 +19,12 @@
  *
  */
 
+/**
+ * \file
+ * \ingroup mpi
+ * Implementation of classes ns3::NullMessageSentBuffer and ns3::NullMessageMpiInterface.
+ */
+
 #include "null-message-mpi-interface.h"
 
 #include "null-message-simulator-impl.h"
@@ -42,6 +48,47 @@
 namespace ns3 {
 
 NS_LOG_COMPONENT_DEFINE ("NullMessageMpiInterface");
+  
+NS_OBJECT_ENSURE_REGISTERED (NullMessageMpiInterface);
+
+/**
+ * \ingroup mpi
+ *
+ * \brief Non-blocking send buffers for Null Message implementation.
+ * 
+ * One buffer is allocated for each non-blocking send.
+ */
+class NullMessageSentBuffer
+{
+public:
+  NullMessageSentBuffer ();
+  ~NullMessageSentBuffer ();
+
+  /**
+   * \return pointer to sent buffer
+   */
+  uint8_t* GetBuffer ();
+  /**
+   * \param buffer pointer to sent buffer
+   */
+  void SetBuffer (uint8_t* buffer);
+  /**
+   * \return MPI request
+   */
+  MPI_Request* GetRequest ();
+
+private:
+
+  /**
+   * Buffer for send.
+   */
+  uint8_t* m_buffer;
+
+  /**
+   * MPI request posted for the send.
+   */
+  MPI_Request m_request;
+};
 
 /**
  * maximum MPI message size for easy
@@ -81,13 +128,26 @@
 uint32_t              NullMessageMpiInterface::g_sid = 0;
 uint32_t              NullMessageMpiInterface::g_size = 1;
 uint32_t              NullMessageMpiInterface::g_numNeighbors = 0;
-bool                  NullMessageMpiInterface::g_initialized = false;
 bool                  NullMessageMpiInterface::g_enabled = false;
+bool                  NullMessageMpiInterface::g_mpiInitCalled = false;
+
 std::list<NullMessageSentBuffer> NullMessageMpiInterface::g_pendingTx;
 
+MPI_Comm     NullMessageMpiInterface::g_communicator = MPI_COMM_WORLD;
+bool         NullMessageMpiInterface::g_freeCommunicator = false;
 MPI_Request* NullMessageMpiInterface::g_requests;
 char**       NullMessageMpiInterface::g_pRxBuffers;
 
+TypeId 
+NullMessageMpiInterface::GetTypeId (void)
+{
+  static TypeId tid = TypeId ("ns3::NullMessageMpiInterface")
+    .SetParent<Object> ()
+    .SetGroupName ("Mpi")
+  ;
+  return tid;
+}
+
 NullMessageMpiInterface::NullMessageMpiInterface ()
 {
   NS_LOG_FUNCTION (this);
@@ -118,14 +178,16 @@
   return g_size;
 }
 
+MPI_Comm 
+NullMessageMpiInterface::GetCommunicator() 
+{
+  NS_ASSERT (g_enabled);
+  return g_communicator;
+}
+
 bool
 NullMessageMpiInterface::IsEnabled ()
 {
-  if (!g_initialized)
-    {
-      Simulator::GetImplementation ();
-      g_initialized = true;
-    }
   return g_enabled;
 }
 
@@ -134,21 +196,39 @@
 {
   NS_LOG_FUNCTION (this << *pargc);
 
+  NS_ASSERT (g_enabled == false);
+
   // Initialize the MPI interface
   MPI_Init (pargc, pargv);
-  MPI_Barrier (MPI_COMM_WORLD);
+  Enable (MPI_COMM_WORLD);
+  g_mpiInitCalled = true;
+}
+
+void 
+NullMessageMpiInterface::Enable (MPI_Comm communicator)
+{
+  NS_LOG_FUNCTION (this);
+
+  NS_ASSERT (g_enabled == false);
+
+  // Standard MPI practice is to duplicate the communicator for
+  // library to use.  Library communicates in isolated communication
+  // context.
+  MPI_Comm_dup (communicator, &g_communicator);
+  g_freeCommunicator = true;
 
   // SystemId and Size are unit32_t in interface but MPI uses int so convert.
   int mpiSystemId;
   int mpiSize;
-  MPI_Comm_rank (MPI_COMM_WORLD, &mpiSystemId);
-  MPI_Comm_size (MPI_COMM_WORLD, &mpiSize);
-
+  MPI_Comm_rank (g_communicator, &mpiSystemId);
+  MPI_Comm_size (g_communicator, &mpiSize);
+  
   g_sid = mpiSystemId;
   g_size = mpiSize;
 
   g_enabled = true;
-  g_initialized = true;
+
+  MPI_Barrier(g_communicator);
 }
 
 void 
@@ -170,7 +250,7 @@
         {
           g_pRxBuffers[index] = new char[NULL_MESSAGE_MAX_MPI_MSG_SIZE];
           MPI_Irecv (g_pRxBuffers[index], NULL_MESSAGE_MAX_MPI_MSG_SIZE, MPI_CHAR, rank, 0,
-                     MPI_COMM_WORLD, &g_requests[index]);
+                     g_communicator, &g_requests[index]);
           ++index;
         }
     }
@@ -210,7 +290,7 @@
   p->Serialize (reinterpret_cast<uint8_t *> (pData), serializedSize);
 
   MPI_Isend (reinterpret_cast<void *> (iter->GetBuffer ()), bufferSize, MPI_CHAR, nodeSysId,
-             0, MPI_COMM_WORLD, (iter->GetRequest ()));
+             0, g_communicator, (iter->GetRequest ()));
 
   NullMessageSimulatorImpl::GetInstance ()->RescheduleNullMessageEvent (nodeSysId);
 }
@@ -241,7 +321,7 @@
   uint32_t nodeSysId = bundle->GetSystemId ();
 
   MPI_Isend (reinterpret_cast<void *> (iter->GetBuffer ()), bufferSize, MPI_CHAR, nodeSysId,
-             0, MPI_COMM_WORLD, (iter->GetRequest ()));
+             0, g_communicator, (iter->GetRequest ()));
 }
 
 void
@@ -261,7 +341,6 @@
   ReceiveMessages(false);
 }
 
-
 void
 NullMessageMpiInterface::ReceiveMessages (bool blocking)
 {
@@ -348,7 +427,7 @@
 
           // Re-queue the next read
           MPI_Irecv (g_pRxBuffers[index], NULL_MESSAGE_MAX_MPI_MSG_SIZE, MPI_CHAR, status.MPI_SOURCE, 0,
-                     MPI_COMM_WORLD, &g_requests[index]);
+                     g_communicator, &g_requests[index]);
 
         }
       else
@@ -387,11 +466,8 @@
 {
   NS_LOG_FUNCTION (this);
 
-  int flag = 0;
-  MPI_Initialized (&flag);
-  if (flag)
+  if (g_enabled)
     {
-
       for (std::list<NullMessageSentBuffer>::iterator iter = g_pendingTx.begin ();
            iter != g_pendingTx.end ();
            ++iter)
@@ -406,7 +482,6 @@
           MPI_Request_free (&g_requests[i]);
         }
 
-      MPI_Finalize ();
 
       for (uint32_t i = 0; i < g_numNeighbors; ++i)
         {
@@ -417,9 +492,29 @@
 
       g_pendingTx.clear ();
 
-      g_enabled = false;
-      g_initialized = false;
 
+      if (g_freeCommunicator)
+        {
+          MPI_Comm_free (&g_communicator);
+          g_freeCommunicator = false;
+        }
+  
+      if (g_mpiInitCalled)
+        {
+          int flag = 0;
+          MPI_Initialized (&flag);
+          if (flag)
+            {
+              MPI_Finalize ();
+            }
+          else
+            {
+              NS_FATAL_ERROR ("Cannot disable MPI environment without Initializing it first");
+            }
+        }
+
+      g_enabled = false;
+      g_mpiInitCalled = false;
     }
   else
     {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.32/src/mpi/model/null-message-mpi-interface.h ns-3.33/src/mpi/model/null-message-mpi-interface.h
--- ns-3.32/src/mpi/model/null-message-mpi-interface.h	2020-10-06 15:35:43.000000000 -0700
+++ ns-3.33/src/mpi/model/null-message-mpi-interface.h	2021-01-09 10:19:22.000000000 -0800
@@ -16,7 +16,12 @@
  * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
  *
  * Author: Steven Smith <smith84@llnl.gov>
- *
+ */
+
+/**
+ * \file
+ * \ingroup mpi
+ * Declaration of classes ns3::NullMessageSentBuffer and ns3::NullMessageMpiInterface.
  */
 
 #ifndef NS3_NULLMESSAGE_MPI_INTERFACE_H
@@ -32,132 +37,68 @@
 
 namespace ns3 {
 
+class NullMessageSimulatorImpl;
+class NullMessageSentBuffer;
 class RemoteChannelBundle;
 class Packet;
 
 /**
  * \ingroup mpi
  *
- * \brief Non-blocking send buffers for Null Message implementation.
- * 
- * One buffer is allocated for each non-blocking send.
- */
-class NullMessageSentBuffer
-{
-public:
-  NullMessageSentBuffer ();
-  ~NullMessageSentBuffer ();
-
-  /**
-   * \return pointer to sent buffer
-   */
-  uint8_t* GetBuffer ();
-  /**
-   * \param buffer pointer to sent buffer
-   */
-  void SetBuffer (uint8_t* buffer);
-  /**
-   * \return MPI request
-   */
-  MPI_Request* GetRequest ();
-
-private:
-
-  /**
-   * Buffer for send.
-   */
-  uint8_t* m_buffer;
-
-  /**
-   * MPI request posted for the send.
-   */
-  MPI_Request m_request;
-};
-
-/**
- * \ingroup mpi
- *
  * \brief Interface between ns-3 and MPI for the Null Message
  * distributed simulation implementation.
  */
-class NullMessageMpiInterface : public ParallelCommunicationInterface
+class NullMessageMpiInterface : public ParallelCommunicationInterface, Object
 {
 public:
+  /**
+   *  Register this type.
+   *  \return The object TypeId.
+   */
+  static TypeId GetTypeId (void);
 
   NullMessageMpiInterface ();
   ~NullMessageMpiInterface ();
 
-  /**
-   * Delete all buffers
-   */
+  // Inherited
   virtual void Destroy ();
-  /**
-   * \return system id (MPI rank)
-   */
   virtual uint32_t GetSystemId ();
-  /**
-   * \return number of systems (MPI size)
-   */
   virtual uint32_t GetSize ();
-  /**
-   * \return true if interface is enabled
-   */
   virtual bool IsEnabled ();
-  /**
-   * \param pargc number of command line arguments
-   * \param pargv command line arguments
-   *
-   * Sets up interface.   Calls MPI Init and 
-   * posts receives.
-   */
   virtual void Enable (int* pargc, char*** pargv);
-  /**
-   * Terminates the MPI environment by calling MPI_Finalize This
-   * function must be called after Destroy ().  Resets m_initialized
-   * and m_enabled.
-   */
+  virtual void Enable (MPI_Comm communicator);
   virtual void Disable ();
-  /**
-   * \param p packet to send
-   * \param rxTime received time at destination node
-   * \param node destination node
-   * \param dev destination device
-   *
-   * Serialize and send a packet to the specified node and net device.
-   *
-   * \internal
-   * The MPI buffer format packs a delivery information and the serialized packet.
-   *
-   * uint64_t time the packed should be delivered
-   * uint64_t guarantee time for the Null Message algorithm.
-   * uint32_t node id of destination
-   * unit32_t dev id on destination
-   * uint8_t[] serialized packet
-   */
   virtual void SendPacket (Ptr<Packet> p, const Time &rxTime, uint32_t node, uint32_t dev);
+  virtual MPI_Comm GetCommunicator();
+
+private:
+
+  /**
+   * The null message implementation is a collaboration of several
+   * classes.  Methods that should be invoked only by the
+   * collaborators are private to restrict use.
+   * It is not intended for state to be shared.
+   */
+  friend ns3::RemoteChannelBundle;
+  friend ns3::NullMessageSimulatorImpl;
+  
   /**
-   * \param guaranteeUpdate guarantee update time for the Null Message
-   * \bundle the destination bundle for the Null Message.
-   *
    * \brief Send a Null Message to across the specified bundle.  
    *
-   * Guarantee update time is the lower bound time on the next
-   * possible event from this MPI task to the remote MPI task across
-   * the bundle.  Remote task may execute events up to time.
-   *
    * Null Messages are sent when a packet has not been sent across
    * this bundle in order to allow time advancement on the remote
    * MPI task.
    *
-   * \internal
-   * The Null Message MPI buffer format is based on the format for sending a packet with
-   * several fields set to 0 to signal that it is a Null Message.  Overloading the normal packet
-   * format simplifies receive logic.
-   *
-   * uint64_t 0 must be zero for Null Message
-   * uint64_t guarantee time
-   * uint32_t 0 must be zero for Null Message
-   * uint32_t 0 must be zero for Null Message
+   * \param [in] guaranteeUpdate Lower bound time on the next
+   * possible event from this MPI task to the remote MPI task across
+   * the bundle.  Remote task may execute events up to this time.
+   *
+   * \param [in] bundle The bundle of links between two ranks.
+   *
+   * \internal The Null Message MPI buffer format uses the same packet
+   * metadata format as sending a normal packet with the time,
+   * destination node, and destination device set to zero.  Using the
+   * same packet metadata simplifies receive logic.
    */
   static void SendNullMessage (const Time& guaranteeUpdate, Ptr<RemoteChannelBundle> bundle);
   /**
@@ -183,37 +124,49 @@
    */
   static void InitializeSendReceiveBuffers (void);
 
-private:
-
   /**
    * Check for received messages complete.  Will block until message
    * has been received if blocking flag is true.  When blocking will
    * return after the first message is received.   Non-blocking mode will
-   * Non-blocking check for received messages complete.  Will
-   * receive all messages that are queued up locally.
+   * only check for received messages complete, and return 
+   * all messages that are queued up locally.
+   *
+   * \param [in] blocking Whether this call should block.
    */
   static void ReceiveMessages (bool blocking = false);
 
-  // System ID (rank) for this task
+  /** System ID (rank) for this task. */
   static uint32_t g_sid;
 
-  // Size of the MPI COM_WORLD group.
+  /** Size of the MPI COM_WORLD group. */
   static uint32_t g_size;
 
-  // Number of neighbor tasks, tasks that this task shares a link with.
+  /** Number of neighbor tasks, tasks that this task shares a link with. */
   static uint32_t g_numNeighbors;
 
-  static bool     g_initialized;
+  /** Has this interface been enabled. */
   static bool     g_enabled;
 
-  // Pending non-blocking receives
+  /**
+   * Has MPI Init been called by this interface.
+   * Alternatively user supplies a communicator.
+   */
+  static bool     g_mpiInitCalled;
+
+  /** Pending non-blocking receives. */
   static MPI_Request* g_requests;
 
-  // Data buffers for non-blocking receives
+  /** Data buffers for non-blocking receives. */
   static char**   g_pRxBuffers;
 
-  // List of pending non-blocking sends
+  /** List of pending non-blocking sends. */
   static std::list<NullMessageSentBuffer> g_pendingTx;
+
+  /** MPI communicator being used for ns-3 tasks. */
+  static MPI_Comm g_communicator;
+
+  /** Did we create the communicator?  Have to free it. */
+  static bool g_freeCommunicator;
 };
 
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.32/src/mpi/model/null-message-simulator-impl.cc ns-3.33/src/mpi/model/null-message-simulator-impl.cc
--- ns-3.32/src/mpi/model/null-message-simulator-impl.cc	2020-10-06 15:35:43.000000000 -0700
+++ ns-3.33/src/mpi/model/null-message-simulator-impl.cc	2021-01-09 10:19:22.000000000 -0800
@@ -16,9 +16,15 @@
  * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
  *
  * Author: Steven Smith <smith84@llnl.gov>
- *
  */
 
+/**
+ * \file
+ * \ingroup mpi
+ * Implementation of class ns3::NullMessageSimulatorImpl.
+ */
+
+
 #include "null-message-simulator-impl.h"
 
 #include "null-message-mpi-interface.h"
@@ -370,14 +376,6 @@
 }
 
 void
-NullMessageSimulatorImpl::RunOneEvent (void)
-{
-  NS_LOG_FUNCTION (this);
-
-  ProcessOneEvent ();
-}
-
-void
 NullMessageSimulatorImpl::Stop (void)
 {
   NS_LOG_FUNCTION (this);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.32/src/mpi/model/null-message-simulator-impl.h ns-3.33/src/mpi/model/null-message-simulator-impl.h
--- ns-3.32/src/mpi/model/null-message-simulator-impl.h	2020-10-06 15:35:43.000000000 -0700
+++ ns-3.33/src/mpi/model/null-message-simulator-impl.h	2021-01-09 10:19:22.000000000 -0800
@@ -16,9 +16,15 @@
  * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
  *
  * Author: Steven Smith <smith84@llnl.gov>
- *
  */
 
+/**
+ * \file
+ * \ingroup mpi
+ * Declaration of class ns3::NullMessageSimulatorImpl. 
+ */
+
+
 #ifndef NULLMESSAGE_SIMULATOR_IMPL_H
 #define NULLMESSAGE_SIMULATOR_IMPL_H
 
@@ -45,10 +51,16 @@
 class NullMessageSimulatorImpl : public SimulatorImpl
 {
 public:
+  /**
+   *  Register this type.
+   *  \return The object TypeId.
+   */
   static TypeId GetTypeId (void);
 
+  /** Default constructor. */
   NullMessageSimulatorImpl ();
 
+  /** Destructor. */
   ~NullMessageSimulatorImpl ();
 
   // virtual from SimulatorImpl
@@ -64,7 +76,7 @@
   virtual void Cancel (const EventId &id);
   virtual bool IsExpired (const EventId &id) const;
   virtual void Run (void);
-  virtual void RunOneEvent (void);
+
   virtual Time Now (void) const;
   virtual Time GetDelayLeft (const EventId &id) const;
   virtual Time GetMaximumSimulationTime (void) const;
@@ -98,7 +110,7 @@
   virtual void DoDispose (void);
 
   /**
-   * Calculate the look ahead allowable for this MPI task.   Basically
+   * Calculate the lookahead allowable for this MPI task.   Basically
    * the minimum latency on links to neighbor MPI tasks.
    */
   void CalculateLookAhead (void);
@@ -168,31 +180,42 @@
    */
   void NullMessageEventHandler(RemoteChannelBundle* bundle);
 
+  /** Container type for the events to run at Simulator::Destroy(). */
   typedef std::list<EventId> DestroyEvents;
 
+  /** The container of events to run at Destroy() */
   DestroyEvents m_destroyEvents;
+  /** Flag calling for the end of the simulation. */
   bool m_stop;
+  /** The event priority queue. */
   Ptr<Scheduler> m_events;
+
+  /** Next event unique id. */
   uint32_t m_uid;
+  /** Unique id of the current event. */
   uint32_t m_currentUid;
+  /** Timestamp of the current event. */
   uint64_t m_currentTs;
+  /** Execution context of the current event. */
   uint32_t m_currentContext;
   /** The event count. */
   uint64_t m_eventCount;
-  // number of events that have been inserted but not yet scheduled,
-  // not counting the "destroy" events; this is used for validation
+  /**
+   * Number of events that have been inserted but not yet scheduled,
+   * not counting the "destroy" events; this is used for validation.
+   */
   int m_unscheduledEvents;
 
-  uint32_t     m_myId;        // MPI Rank
-  uint32_t     m_systemCount; // MPI Size
+  uint32_t     m_myId;        /**< MPI rank. */
+  uint32_t     m_systemCount; /**< MPI communicator size. */
 
-  /*
+  /**
    * The time for which it is safe for this task to execute events
    * without danger of out-of-order events.
    */
   Time m_safeTime;
 
-  /*
+  /**
    * Null Message performance tuning parameter.  Controls when Null
    * messages are sent.  When value is 1 the minimum number of Null
    * messages are sent conserving bandwidth.  The delay in arrival of
@@ -204,9 +227,7 @@
    */
   double m_schedulerTune;
 
-  /*
-   * Singleton instance.
-   */
+  /** Singleton instance. */
   static NullMessageSimulatorImpl* g_instance;
 };
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.32/src/mpi/model/parallel-communication-interface.h ns-3.33/src/mpi/model/parallel-communication-interface.h
--- ns-3.32/src/mpi/model/parallel-communication-interface.h	2020-10-06 15:35:43.000000000 -0700
+++ ns-3.33/src/mpi/model/parallel-communication-interface.h	2021-01-09 10:19:22.000000000 -0800
@@ -19,6 +19,12 @@
  *
  */
 
+/**
+ * \file
+ * \ingroup mpi
+ * Declaration of class ns3::ParallelCommunicationInterface.
+ */
+
 #ifndef NS3_PARALLEL_COMMUNICATION_INTERFACE_H
 #define NS3_PARALLEL_COMMUNICATION_INTERFACE_H
 
@@ -40,11 +46,17 @@
  * \brief Pure virtual base class for the interface between ns-3 and
  * the parallel communication layer being used.
  *
- * Each type of parallel communication layer is required to implement
- * this interface.  This interface is called through the
- * MpiInterface.
+ * This class is implemented for each of the parallel versions of
+ * SimulatorImpl to manage communication between process (ranks).
+ *
+ * This interface is called through the singleton MpiInterface class.
+ * MpiInterface has the same API as ParallelCommunicationInterface but
+ * being a singleton uses static methods to delegate to methods
+ * defined in classes that implement the
+ * ParallelCommunicationInterface.  For example, SendPacket is likely
+ * to be specialized for a specific parallel SimulatorImpl.
  */
-  class ParallelCommunicationInterface
+class ParallelCommunicationInterface
 {
 public:
   /**
@@ -52,43 +64,41 @@
     */
   virtual ~ParallelCommunicationInterface() {}
   /**
-   * Deletes storage used by the parallel environment.
+   * \copydoc MpiInterface::Destroy
    */
   virtual void Destroy () = 0;
   /**
-   * \return system identification
+   * \copydoc MpiInterface::GetSystemId
    */
   virtual uint32_t GetSystemId () = 0;
   /**
-   * \return number of parallel tasks
+   * \copydoc MpiInterface::GetSize
    */
   virtual uint32_t GetSize () = 0;
   /**
-   * \return true if parallel communication is enabled
+   * \copydoc MpiInterface::IsEnabled
    */
   virtual bool IsEnabled () = 0;
   /**
-   * \param pargc number of command line arguments
-   * \param pargv command line arguments
-   *
-   * Sets up parallel communication interface
+   * \copydoc MpiInterface::Enable(int* pargc,char*** pargv)
    */
   virtual void Enable (int* pargc, char*** pargv) = 0;
   /**
-   * Terminates the parallel environment.
-   * This function must be called after Destroy ()
+   * \copydoc MpiInterface::Enable(MPI_Comm communicator)
+   */
+  virtual void Enable (MPI_Comm communicator) = 0;
+  /**
+   * \copydoc MpiInterface::Disable
    */
   virtual void Disable () = 0;
   /**
-   * \param p packet to send
-   * \param rxTime received time at destination node
-   * \param node destination node
-   * \param dev destination device
-   *
-   * Serialize and send a packet to the specified node and net device
+   * \copydoc MpiInterface::SendPacket
    */
   virtual void SendPacket (Ptr<Packet> p, const Time &rxTime, uint32_t node, uint32_t dev) = 0;
-
+  /**
+   * \copydoc MpiInterface::GetCommunicator
+   */
+  virtual MPI_Comm GetCommunicator () = 0;
 private:
 };
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.32/src/mpi/model/remote-channel-bundle.cc ns-3.33/src/mpi/model/remote-channel-bundle.cc
--- ns-3.32/src/mpi/model/remote-channel-bundle.cc	2020-10-06 15:35:43.000000000 -0700
+++ ns-3.33/src/mpi/model/remote-channel-bundle.cc	2021-01-09 10:19:22.000000000 -0800
@@ -19,6 +19,12 @@
  *
  */
 
+/**
+ * \file
+ * \ingroup mpi
+ * Implementation of class ns3::RemoteChannelBundle.
+ */
+
 #include "remote-channel-bundle.h"
 
 #include "null-message-mpi-interface.h"
@@ -28,7 +34,6 @@
 
 namespace ns3 {
 
-#define NS_TIME_INFINITY ns3::Time (0x7fffffffffffffffLL)
 
 TypeId RemoteChannelBundle::GetTypeId (void)
 {
@@ -42,14 +47,14 @@
 RemoteChannelBundle::RemoteChannelBundle ()
   : m_remoteSystemId (UINT32_MAX),
     m_guaranteeTime (0),
-    m_delay (NS_TIME_INFINITY)
+    m_delay (Time::Max ())
 {
 }
 
 RemoteChannelBundle::RemoteChannelBundle (const uint32_t remoteSystemId)
   : m_remoteSystemId (remoteSystemId),
     m_guaranteeTime (0),
-    m_delay (NS_TIME_INFINITY)
+    m_delay (Time::Max ())
 {
 }
 
@@ -115,12 +120,10 @@
   out << "RemoteChannelBundle Rank = " << bundle.m_remoteSystemId
       << ", GuaranteeTime = "  << bundle.m_guaranteeTime
       << ", Delay = " << bundle.m_delay << std::endl;
-  
-  for (std::map < uint32_t, Ptr < Channel > > ::const_iterator pair = bundle.m_channels.begin ();
-       pair != bundle.m_channels.end ();
-       ++pair)
+
+  for (auto element : bundle.m_channels)
     {
-      out << "\t" << (*pair).second << std::endl;
+      out << "\t" << element.second << std::endl;
     }
   
   return out;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.32/src/mpi/model/remote-channel-bundle.h ns-3.33/src/mpi/model/remote-channel-bundle.h
--- ns-3.32/src/mpi/model/remote-channel-bundle.h	2020-10-06 15:35:43.000000000 -0700
+++ ns-3.33/src/mpi/model/remote-channel-bundle.h	2021-01-09 10:19:22.000000000 -0800
@@ -19,6 +19,12 @@
  *
  */
 
+/**
+ * \file
+ * \ingroup mpi
+ * Declaration of class ns3::RemoteChannelBundle.
+ */
+
 #ifndef NS3_REMOTE_CHANNEL_BUNDLE
 #define NS3_REMOTE_CHANNEL_BUNDLE
 
@@ -28,14 +34,14 @@
 #include <ns3/ptr.h>
 #include <ns3/pointer.h>
 
-#include <map>
+#include <unordered_map>
 
 namespace ns3 {
 
 /**
  * \ingroup mpi
  * 
- * \brief Collection of NS3 channels between local and remote nodes.
+ * \brief Collection of ns-3 channels between local and remote nodes.
  * 
  * An instance exists for each remote system that the local system is
  * in communication with.  These are created and managed by the
@@ -45,34 +51,47 @@
 class RemoteChannelBundle : public Object
 {
 public:
+  /**
+   *  Register this type.
+   *  \return The object TypeId.
+   */
   static TypeId GetTypeId (void);
 
+  /** Default constructor. */
   RemoteChannelBundle ();
 
+  /**
+   * Construct and assing system Id.
+   * \param [in] remoteSystemId The system id.
+   */
   RemoteChannelBundle (const uint32_t remoteSystemId);
 
+  /** Destructor. */
   ~RemoteChannelBundle ()
   {
   }
 
   /**
+   * Add a channel to this bundle.
    * \param channel to add to the bundle
    * \param delay time for the channel (usually the latency)
    */
   void AddChannel (Ptr<Channel> channel, Time delay);
 
   /**
+   * Get the system Id for this side.
    * \return SystemID for remote side of this bundle
    */
   uint32_t GetSystemId () const;
 
   /**
+   * Get the current guarantee time for this bundle.
    * \return guarantee time
    */
   Time GetGuaranteeTime (void) const;
 
   /**
-   * \param guarantee time
+   * \param time The guarantee time.
    *
    * Set the guarantee time for the bundle.  This should be called
    * after a packet or Null Message received.
@@ -80,28 +99,33 @@
   void SetGuaranteeTime (Time time);
 
   /**
-   * \return the minimum delay along any channel in this bundle
+   * Get the minimum delay along any channel in this bundle
+   * \return The minimum delay.
    */
   Time GetDelay (void) const;
 
   /**
-   * Set the event ID of the Null Message send event current scheduled
+   * Set the event ID of the Null Message send event currently scheduled
    * for this channel.
+   *
+   * \param [in] id The null message event id.
    */
   void SetEventId (EventId id);
 
   /**
-   * \return the event ID of the Null Message send event for this bundle
+   * Get the event ID of the Null Message send event for this bundle
+   * \return The null message event id.
    */
   EventId GetEventId (void) const;
 
   /**
-   * \return number of NS3 channels in this bundle
+   * Get the number of ns-3 channels in this bundle
+   * \return The number of channels.
    */
   std::size_t GetSize (void) const;
 
   /**
-   * \param time 
+   * \param time The delay from now when the null message should be received.
    *
    * Send Null Message to the remote task associated with this bundle.
    * Message will be delivered at current simulation time + the time
@@ -111,37 +135,39 @@
 
   /**
    * Output for debugging purposes.
+   *
+   * \param [in,out] out The stream.
+   * \param [in] bundle The bundle to print.
+   * \return The stream.
    */
   friend std::ostream& operator<< (std::ostream& out, ns3::RemoteChannelBundle& bundle );
 
 private:
-  /*
-   * Remote rank.
-   */
+  /** Remote rank. */
   uint32_t m_remoteSystemId;
 
-  /*
-   * NS3 Channels that are connected from nodes in this MPI task to remote_rank.
-   *
-   * Would be more efficient to use unordered_map when C++11 is adopted by NS3.
+  /**
+   * Container of channels that are connected from nodes in this MPI task
+   * to nodes in a remote rank.
    */
-  std::map < uint32_t, Ptr < Channel > > m_channels;
+  typedef std::unordered_map < uint32_t, Ptr < Channel > > ChannelMap;
+  ChannelMap m_channels; /**< ChannelId to Channel map */
 
-  /*
+  /**
    * Guarantee time for the incoming Channels from MPI task remote_rank.
-   * No PacketMessage will ever arrive on any incoming channel in this bundle with a
-   * ReceiveTime less than this.  Initialized to StartTime.
+   * No PacketMessage will ever arrive on any incoming channel
+   * in this bundle with a ReceiveTime less than this.
+   * Initialized to StartTime.
    */
   Time m_guaranteeTime;
 
-  /*
-   * Delay for this Channel bundle.   min link delay over all incoming channels;
+  /**
+   * Delay for this Channel bundle, which is
+   * the min link delay over all incoming channels;
    */
   Time m_delay;
 
-  /*
-   * Event scheduled to send Null Message for this bundle.
-   */
+  /** Event scheduled to send Null Message for this bundle. */
   EventId m_nullEventId;
 
 };
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.32/src/mpi/model/remote-channel-bundle-manager.cc ns-3.33/src/mpi/model/remote-channel-bundle-manager.cc
--- ns-3.32/src/mpi/model/remote-channel-bundle-manager.cc	2020-10-06 15:35:43.000000000 -0700
+++ ns-3.33/src/mpi/model/remote-channel-bundle-manager.cc	2021-01-09 10:19:22.000000000 -0800
@@ -19,6 +19,12 @@
  *
  */
 
+/**
+ * \file
+ * \ingroup mpi
+ * Implementation of class ns3::RemoteChannelBundleManager.
+ */
+
 #include "remote-channel-bundle-manager.h"
 
 #include "remote-channel-bundle.h"
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.32/src/mpi/model/remote-channel-bundle-manager.h ns-3.33/src/mpi/model/remote-channel-bundle-manager.h
--- ns-3.32/src/mpi/model/remote-channel-bundle-manager.h	2020-10-06 15:35:43.000000000 -0700
+++ ns-3.33/src/mpi/model/remote-channel-bundle-manager.h	2021-01-09 10:19:22.000000000 -0800
@@ -19,18 +19,24 @@
  *
  */
 
+/**
+ * \file
+ * \ingroup mpi
+ * Declaration of class ns3::RemoteChannelBundleManager.
+ */
+
 #ifndef NS3_REMOTE_CHANNEL_BUNDLE_MANAGER
 #define NS3_REMOTE_CHANNEL_BUNDLE_MANAGER
 
 #include <ns3/nstime.h>
 #include <ns3/ptr.h>
-#include <map>
+#include <unordered_map>
 
 namespace ns3 {
 
 class RemoteChannelBundle;
 
-/*
+  /**
  * \ingroup mpi
  * 
  * \brief Singleton for managing the RemoteChannelBundles for each process.
@@ -42,19 +48,26 @@
 
 public:
   /**
-   * \return remote channel bundle for specified SystemId.
+   * Get the bundle corresponding to a remote rank.
+   *
+   * \param [in] systemId The remote system id.
+   * \return The bundle for the specified system id.
    */
   static Ptr<RemoteChannelBundle> Find (uint32_t systemId);
 
   /**
-   * Add RemoteChannelBundle from this task to MPI task on other side of the link.
+   * Add RemoteChannelBundle from this task to MPI task
+   * on other side of the link.
    * Can not be invoked after InitializeNullMessageEvents has been invoked.
+   *
+   * \param [in] systemId The remote system id.
+   * \return The newly added bundle.
    */
   static Ptr<RemoteChannelBundle> Add (uint32_t systemId);
 
   /**
-   * \return number of remote channel bundles
-   * 
+   * Get the number of ns-3 channels in this bundle
+   * \return The number of channels.
    */
   static std::size_t Size (void);
 
@@ -65,13 +78,12 @@
   static void InitializeNullMessageEvents (void);
 
   /**
-   * \return safe time across all remote channels.
+   * Get the safe time across all channels in this bundle.
+   * \return The safe time.
    */
   static Time GetSafeTime (void);
 
-  /**
-   * Destroy the singleton.
-   */
+  /** Destroy the singleton. */
   static void Destroy (void);
 
 private:
@@ -83,19 +95,22 @@
   {
   }
 
+  /**
+   * Private dtor to prevent destruction outside of singleton pattern. 
+   */
   ~RemoteChannelBundleManager ()
   {
   }
 
-  /*
+  /**
    * Container for all remote channel bundles for this task.
    *
-   * Would be more efficient to use unordered_map when C++11 is adopted for NS3.
    */
-  typedef std::map<uint32_t, Ptr<RemoteChannelBundle> > RemoteChannelMap;
+  typedef std::unordered_map<uint32_t, Ptr<RemoteChannelBundle> > RemoteChannelMap;
+  /** The remote channel bundles. */
   static RemoteChannelMap g_remoteChannelBundles;
 
-  /*
+  /**
    * Protect manager class from being initialized twice or incorrect
    * ordering of method calls.
    */
